// This file was generated by gir (https://github.com/gtk-rs/gir)
// from gir-files (https://github.com/gtk-rs/gir-files)
// DO NOT EDIT

#[cfg(any(feature = "v0_7_8", feature = "dox"))]
use AgreementKind;
use AgreementSection;
use app_stream_glib_sys;
#[cfg(any(feature = "v0_7_8", feature = "dox"))]
use glib::GString;
use glib::object::IsA;
use glib::translate::*;
use std::fmt;

glib_wrapper! {
    pub struct Agreement(Object<app_stream_glib_sys::AsAgreement, app_stream_glib_sys::AsAgreementClass, AgreementClass>);

    match fn {
        get_type => || app_stream_glib_sys::as_agreement_get_type(),
    }
}

impl Agreement {
    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    pub fn new() -> Agreement {
        unsafe {
            from_glib_full(app_stream_glib_sys::as_agreement_new())
        }
    }

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    pub fn kind_from_string(value: &str) -> AgreementKind {
        unsafe {
            from_glib(app_stream_glib_sys::as_agreement_kind_from_string(value.to_glib_none().0))
        }
    }

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    pub fn kind_to_string(value: AgreementKind) -> Option<GString> {
        unsafe {
            from_glib_none(app_stream_glib_sys::as_agreement_kind_to_string(value.to_glib()))
        }
    }
}

#[cfg(any(feature = "v0_7_8", feature = "dox"))]
impl Default for Agreement {
    fn default() -> Self {
        Self::new()
    }
}

pub const NONE_AGREEMENT: Option<&Agreement> = None;

pub trait AgreementExt: 'static {
    fn add_section<P: IsA<AgreementSection>>(&self, agreement_section: &P);

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn get_kind(&self) -> AgreementKind;

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn get_section_default(&self) -> Option<AgreementSection>;

    //#[cfg(any(feature = "v0_7_8", feature = "dox"))]
    //fn get_sections(&self) -> /*Unknown conversion*//*Unimplemented*/PtrArray TypeId { ns_id: 1, id: 6 };

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn get_version_id(&self) -> Option<GString>;

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn set_kind(&self, kind: AgreementKind);

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn set_version_id(&self, version_id: &str);
}

impl<O: IsA<Agreement>> AgreementExt for O {
    fn add_section<P: IsA<AgreementSection>>(&self, agreement_section: &P) {
        unsafe {
            app_stream_glib_sys::as_agreement_add_section(self.as_ref().to_glib_none().0, agreement_section.as_ref().to_glib_none().0);
        }
    }

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn get_kind(&self) -> AgreementKind {
        unsafe {
            from_glib(app_stream_glib_sys::as_agreement_get_kind(self.as_ref().to_glib_none().0))
        }
    }

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn get_section_default(&self) -> Option<AgreementSection> {
        unsafe {
            from_glib_none(app_stream_glib_sys::as_agreement_get_section_default(self.as_ref().to_glib_none().0))
        }
    }

    //#[cfg(any(feature = "v0_7_8", feature = "dox"))]
    //fn get_sections(&self) -> /*Unknown conversion*//*Unimplemented*/PtrArray TypeId { ns_id: 1, id: 6 } {
    //    unsafe { TODO: call app_stream_glib_sys:as_agreement_get_sections() }
    //}

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn get_version_id(&self) -> Option<GString> {
        unsafe {
            from_glib_none(app_stream_glib_sys::as_agreement_get_version_id(self.as_ref().to_glib_none().0))
        }
    }

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn set_kind(&self, kind: AgreementKind) {
        unsafe {
            app_stream_glib_sys::as_agreement_set_kind(self.as_ref().to_glib_none().0, kind.to_glib());
        }
    }

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn set_version_id(&self, version_id: &str) {
        unsafe {
            app_stream_glib_sys::as_agreement_set_version_id(self.as_ref().to_glib_none().0, version_id.to_glib_none().0);
        }
    }
}

impl fmt::Display for Agreement {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "Agreement")
    }
}
